/* mail.c                               */
/* copyright (c)1997 by Marek Zelem     */
/* e-mail: marek@fornax.elf.stuba.sk    */

#include <stdio.h>
#include <sys/types.h>
#include <sys/wait.h>
#include "tell.h"

#ifdef MAIL_IF_ERR
int mail_error(char *name, char *subject, char *descript, char *text)
{ pid_t pid;
  int fd[2];
  int stat;
  FILE *f;
#ifdef ALLOW_DUMMY_USERS
	if( name[0]=='/' )	return(-1);
#endif ALLOW_DUMMY_USERS
	pipe(fd);
	if( (pid=fork())==0 )
	{	close(0);
		dup(fd[0]); close(fd[0]);
		close(1); close(2);
		close(fd[1]);
		execlp("/usr/sbin/sendmail","sendmail",M_FROM,name,NULL);
		return(-1);
	}
	else if( pid<0 )
	{	printf("%s: Can't fork!\n",me);
		return(-1);
	}
	close(fd[0]);
	if( (f=fdopen(fd[1],"w"))!=NULL )
	{	fprintf(f,"From: %s\nTo: %s\nSubject: %s\n\n"
			,MAIL_FROM,name,subject);
		fprintf(f,"%s\n-------- text --------\n",descript);
		fwrite(text,strlen(text),1,f);
		fclose(f);
	}
	close(fd[1]);
	waitpid(pid,&stat,0);
	return(0);
}
#endif MAIL_IF_ERR

